/*
 * Copyright (c) 2009 Jess Nuevo Chiquero - UAH
 *
 * This file is part of RawVideoTools
 *
 * RawVideoTools is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * RawVideoTools is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */


#include <string.h>

#include <stdlib.h>
#include <stdio.h>
#include <error.h>
#include <errno.h>

#include <fstream>

#include <sys/time.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/select.h>

#include <dirent.h>

#include <vector>
#include <stdexcept>

#include <string>
#include <iostream>
#include <fstream>

#include <cv.h>
#include <cxcore.h>
#include <highgui.h>

#include <time.h>

#include "raw_video_reader.hh"

int main(int argc, char *argv[])
{

    RawVideoReader rvr;

    rvr.open(argv[1]);


    double val;

    val = rvr.get_property(CV_CAP_PROP_FRAME_COUNT);
    std::cout << "N de frames: " << val;
    val = rvr.get_property(CV_CAP_PROP_FPS);
    std::cout << ", fps: " << val ;
    val = rvr.get_property(CV_CAP_PROP_POS_FRAMES);
    std::cout << ", frame: " << val;
    val = rvr.get_property(CV_CAP_PROP_POS_AVI_RATIO);
    std::cout << ", avi ratio: " << val << std::endl;

    cvNamedWindow("kk");

    const IplImage *img;

    for(uint ai=0; ai< 10; ai++){
	img = rvr.query_frame();

	cvShowImage("kk", img);
	cvWaitKey(0);
    }

    val = rvr.get_property(CV_CAP_PROP_POS_FRAMES);
    std::cout << "frame: " << val<<std::endl;

    val = rvr.get_property(CV_CAP_PROP_FRAME_COUNT);
    
    val = rvr.set_property(CV_CAP_PROP_POS_FRAMES, cvRound(val/2));
    val = rvr.get_property(CV_CAP_PROP_POS_FRAMES);
    std::cout << "frame: " << val<<std::endl;

    for(uint ai=0; ai< 10; ai++){
	img = rvr.query_frame();
	
	cvShowImage("kk", img);
	cvWaitKey(0);
    }
    val = rvr.get_property(CV_CAP_PROP_POS_FRAMES);
    std::cout << "frame: " << val<<std::endl;
    val = rvr.get_property(CV_CAP_PROP_POS_AVI_RATIO);
    std::cout << ", avi ratio: " << val << std::endl;


    return 0;
}
